@ Simple(s) Beispiel
@ GPIO register map is similiar to STM32F4 chips.
        @ -> register boundary address  pp. 65 in DM00031020.pdf
  .equ  BIT0,    0x00000001
  .equ  BIT1,    0x00000002
  .equ  BIT2,    0x00000004
  .equ  BIT3,    0x00000008
  .equ  BIT4,    0x00000010
  .equ  BIT5,    0x00000020
  .equ  BIT6,    0x00000040
  .equ  BIT7,    0x00000080
  .equ  BIT8,    0x00000100
  .equ  BIT9,    0x00000200
  .equ  BIT10,   0x00000400
  .equ  BIT11,   0x00000800
  .equ  BIT12,   0x00001000
  .equ  BIT13,   0x00002000
  .equ  BIT14,   0x00004000
  .equ  BIT15,   0x00008000
  .equ  BIT16,   0x00010000
  .equ  BIT17,   0x00020000
  .equ  BIT18,   0x00040000
  .equ  BIT19,   0x00080000
  .equ  BIT20,   0x00100000
  .equ  BIT21,   0x00200000
  .equ  BIT22,   0x00400000
  .equ  BIT23,   0x00800000
  .equ  BIT24,   0x01000000
  .equ  BIT25,   0x02000000
  .equ  BIT26,   0x04000000
  .equ  BIT27,   0x08000000
  .equ  BIT28,   0x10000000
  .equ  BIT29,   0x20000000
  .equ  BIT30,   0x40000000
  .equ  BIT31,   0x80000000


        .equ GPIOE_BASE      ,   0x40021000

        .equ GPIOE_MODER     ,   GPIOE_BASE + 0x00 @ pp. 287 of DM00031020.pdf
        .equ GPIOE_OTYPER    ,   GPIOE_BASE + 0x04
        .equ GPIOE_ODR       ,   GPIOE_BASE + 0x14

        .equ GPIOB_BASE      ,   0x40020400
        .equ GPIOB_MODER     ,   GPIOB_BASE + 0x00
        .equ GPIOB_OTYPER    ,   GPIOB_BASE + 0x04
        .equ GPIOB_OSPEEDR   ,   GPIOB_BASE + 0x08
        .equ GPIOB_PUPDR     ,   GPIOB_BASE + 0x0C
        .equ GPIOB_IDR       ,   GPIOB_BASE + 0x10
        .equ GPIOB_ODR       ,   GPIOB_BASE + 0x14
        .equ GPIOB_BSRR      ,   GPIOB_BASE + 0x18
        .equ GPIOB_LCKR      ,   GPIOB_BASE + 0x1C
        .equ GPIOB_AFRL      ,   GPIOB_BASE + 0x20
        .equ GPIOB_AFRH      ,   GPIOB_BASE + 0x24
        .equ GPIOB_BRR       ,   GPIOB_BASE + 0x28

        @ System control registers
@ register offsets
.set    RCC_CR,         0x00            @ RCC clock control register
.set    RCC_PLLCFGR,    0x04            @ RCC PLL configuration register
.set    RCC_CFGR,       0x08            @ RCC clock configuration register
.set    RCC_CIR,        0x0C            @ RCC clock interrupt register
.set    RCC_AHB1RSTR,   0x10            @ AHB1 peripheral reset register
.set    RCC_AHB2RSTR,   0x14            @ AHB2 peripheral reset register
.set    RCC_AHB3RSTR,   0x18            @ AHB3 peripheral reset register
.set    RCC_APB1RSTR,   0x20            @ APB1 peripheral reset register
.set    RCC_APB2RSTR,   0x24            @ APB2 peripheral reset register
.set    RCC_AHB1ENR,    0x30            @ AHB1 peripheral clock enable register
.set    RCC_AHB2ENR,    0x34            @ AHB2 peripheral clock enable register
.set    RCC_AHB3ENR,    0x38            @ AHB2 peripheral clock enable register
.set    RCC_APB1ENR,    0x40            @ APB1 peripheral clock enable register
.set    RCC_APB2ENR,    0x44            @ APB2 peripheral clock enable register
.set    RCC_AHB1LPENR,  0x50            @ AHB1 peripheral LP mode clock enable register
.set    RCC_AHB2LPENR,  0x54            @ AHB2 peripheral LP mode clock enable register
.set    RCC_AHB3LPENR,  0x58            @ AHB3 peripheral LP mode clock enable register
.set    RCC_APB1LPENR,  0x60            @ APB1 peripheral LP mode clock enable register
.set    RCC_APB2LPENR,  0x64            @ APB2 peripheral LP mode clock enable register
.set    RCC_BDCR,       0x70            @ RCC backup domain control register
.set    RCC_CSR,        0x74            @ RCC clock control & status register
.set    RCC_SSCGR,      0x80            @ RCC spread spectrum clock generation register
.set    RCC_PLLI2SCFGR, 0x84            @ RCC I2S PLL configuration register


.equ RCC_BASE        ,   0x40023800
.equ RCC_CR          ,   RCC_BASE + 0x00
.equ RCC_CFGR        ,   RCC_BASE + 0x08

.equ RCC_AHB1ENR     ,   RCC_BASE + 0x30
.equ RCC_AHB2ENR     ,   RCC_BASE + 0x34


	 .syntax unified
 	.cpu    cortex-m4
 	.fpu    fpv4-sp-d16
 	.thumb
 	.text
 	.pool
    .global rstHandler,Mstk
	.equ Mstk,0x20000400

	.org	0
	.word	Mstk
	.word	rstHandler + 1

	
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	0			
	.word	0			
	.word	0			
	.word	0			
	.word	defHandler + 1
	.word	defHandler + 1
	.word	0			
	.word	defHandler + 1
	.word	stkHandler + 1

	
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1
	.word	defHandler + 1

	.org 0x400

rstHandler: sub     r4, pc, #8              @
        mov     r1, #1                  @
        ldr     r3, = ResetSrc          @
        ldr     r6, = RCC_BASE               @
        ldrb    r2, [r6, #RCC_CSR + 3]  @
        cbz     r2, 1f                  @
        lsr     r2, r2, #1              @
        ldr     r3, = ResetSrc          @
        str     r2, [r3]                @
        mov     r2, #1                  @
        strb    r2, [r6, #RCC_CSR + 3]

1:      bl      initSys
	    bl kuku
warm:	nop
        b       warm                    @ 
initSys: cpsid   i                       @
        ldr     r0, = Mstk              @
        mov     sp, r0
        isb
        bx lr
kuku:
	push {r0,r1}
@ Turn on the clocks for all GPIOs.
        ldr r1, = RCC_AHB1ENR   @ p. 242 und p. 266 manual RM00090 (Rev 18)
                          	@ dm00031020-stm32f405-415-stm32f407......pdf
	ldr r0, = BIT20+0x1f    @ Enable Port A,B,C,D,E
	str r0, [r1]

	ldr r1, = GPIOE_MODER
	ldr r0, = 0x01      @ bit PE0 to GP Output
	str r0,[r1]

	ldr r1,= GPIOE_OTYPER  @ p. 281
	ldr r0, = 0x01           @ open-drain
	str r0,[r1]

	ldr r1,= GPIOE_ODR     @ LED ON
	ldr r0, = 0x0
	str r0,[r1]
 	pop {r0,r1}
	bx lr

	.global	stkHandler
stkHandler:
	ldr	r1, = SysTicks		
	ldr	r0, [r1]		
	add	r0, r0, #1		
	str	r0, [r1]		
	bx	lr			

@===============================================================================
	.global	defHandler
defHandler:
	ldr	r3, = ExcFrame		
	mrs	r0, ipsr		
	pop	{r1}			
	stm	r3!, {r0, r1}		
	add	sp, sp, #12		
	stm	r3!, {r7 - r11}		
	pop	{r0 - r2}		
	stm	r3!, {r0 - r2}		
	add	r0, sp, #4		
	ldr	r1, [r10]		
	ldr	r2, [r11]		
	ldrh	r4, [r9]		
	stm	r3!, {r0 - r2, r4}	
	b	.			

@===============================================================================

                .global SysTicks, ResetSrc, TimeSlice, ExcFrame
SysTicks:       .space  4
ResetSrc:       .space  4
TimeSlice:      .space  4

ExcFrame:       .space  14 * 4

       .end
